MyProjekt/MyProjekt/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('', include('main.urls')),
    path('admin/', admin.site.urls),
]

MyProjekt/main/urls.py
from django.urls import path

from . import views

urlpatterns = [
    path('', views.IndexView.as_view(), name='index'),
]


# CRUD-Aktionen Referenz-System
urlpatterns += [
    path('references', views.ReferenceList.as_view(), name='referencemodel-list'),
    path('reference/create/', views.ReferenceSystemCreate.as_view(),
         name='referencemodel-create'),
    path('reference/<int:pk>/', views.ReferenceDetail.as_view(),
         name='referencemodel-detail'),
    path('reference/<int:pk>/update/',
         views.ReferenceModelUpdate.as_view(), name='referencemodel-update'),
    path('reference/<int:pk>/delete/',
         views.ReferenceSystemDelete.as_view(), name='referencemodel-delete'),
]

# file upload
urlpatterns += [
    path('refupload/<int:pk>', views.ReferenceUpload.as_view(), name='refupload')
]

# CRUD-Aktionen Technologie
urlpatterns += [
    path('technologies/', views.TechnologyList.as_view(), name='technology-list'),
    path('technology/create/', views.TechnologyCreate.as_view(),
         name='technology-create'),
    path('technology/<int:pk>/', views.TechnologyDetail.as_view(),
         name='technology-detail'),
    path('technology/<int:pk>/update/',
         views.TechnologyUpdate.as_view(), name='technology-update'),
    path('technology/<int:pk>/delete/',
         views.TechnologyDelete.as_view(), name='technology-delete'),
]

# CRUD-Aktionen Tools
urlpatterns += [
    path('tool/<int:pk>/create', views.ToolCreate.as_view(),
         name='tool-create'),
    path('tool/<int:pk>/update',
         views.ToolUpdate.as_view(), name='tool-update'),
    path('tool/<int:pk>/delete/<int:technology_id>',
         views.ToolDelete.as_view(), name='tool-delete'),
]

# CRUD-Aktionen ToolAttributes
urlpatterns += [
    path('tool_attributes/<int:pk>/create', views.ToolAttributeCreate.as_view(),
         name='attr-create'),
    path('tool_attributes/<int:pk>/update',
         views.ToolAttributeUpdate.as_view(), name='attr-update'),
    path('tool_attributes/<int:pk>/delete/<int:technology_id>',
         views.ToolAttributeDelete.as_view(), name='attr-delete'),
]

# CRUD-Aktionen Technologiekette (Model: FctMembership)
urlpatterns += [
    path('reference/<int:pk>/update_technology',
         views.ReferenceModelTechnologyUpdate.as_view(), name='reference-technology'),
    path('reference/<int:pk>/delete_technology/<int:ref>',
         views.ReferenceModelTechnologyDelete.as_view(), name='reference-technology-delete')
]

# CRUD-Aktionen FctTabelle
urlpatterns += [
    path('fct_tabelle/<int:pk>/<int:merkmal>',
         views.FctTableForm.as_view(), name='fct-table')
]

# Redirect \ calculation fct_column volumes
urlpatterns += [
    path('fct_volume/<int:pk>',
         views.CalculateFctTableVolumes.as_view(), name='fct-volume'),

]

# Customer
urlpatterns += [
    path('items', views.CustomerItems.as_view(), name='item-list'),
    path('item/<int:pk>/', views.CustomerItem.as_view(), name='item-detail'),
    path('item/create', views.ItemUpload.as_view(), name='item-create'),
    path('item/<int:pk>/delete',
         views.CustomerItemDelete.as_view(), name='item-delete'),
    path('item/<int:pk>/<int:reference>',
         views.ItemFctBackwards.as_view(), name='item-fct'),
    path('item_compare/<int:pk>/<int:reference>',
         views.ItemComparison.as_view(), name='item-compare'),
    path('item_add/<int:pk>/<int:reference>',
         views.ItemAddFeatureToReference.as_view(), name='item-add')
]

MyProjekt/main/models.py
import math
import decimal
from typing import List
from django.db import models
from django.db.models.base import Model
from django.db.models.fields import BooleanField, CharField,  FloatField, PositiveIntegerField
from django.db.models.fields.related import ForeignKey, ManyToManyField
from django.core.exceptions import ValidationError
from django.urls import reverse

'''
Tabelle für die Technologien
Unterteilung in: 
    Technology, Tool und ToolAttriute
'''


class Technology(models.Model):
    # Maschine
    name = models.CharField(max_length=255)

    # wirtschaftliche Parameter
    restfertigungsgemeinkosten = FloatField()
    anschaffungswert = FloatField()
    verkaufserlös = FloatField()
    abschreibungsdauer = FloatField()
    platzbedarf = FloatField()
    mittlere_leistung = FloatField()
    instandhaltungsfaktor = FloatField()
    quadratmeterpreis = FloatField()
    strompreis = FloatField()
    zinsatz = FloatField()
    stundenlohn = FloatField()
    fertigungsmittelanzahl = FloatField()
    bediehnverhaeltnis = FloatField()

    def get_absolute_url(self):
        return reverse('technology-detail', args=[str(self.id)])

    def __str__(self):
        return f"{self.name}"


class Tool(models.Model):
    # Werkzeug
    name = CharField(max_length=255)
    technology = ForeignKey(Technology, on_delete=models.CASCADE)

    # wirtschaftliche Parameter
    verteilzeit = FloatField()
    ruestzeit = FloatField()
    erholungszeit = FloatField()
    werkzeugwechselzeit = FloatField()
    werkstueckwechselzeit = FloatField()
    betriebsstoffkosten = FloatField()
    werkzeugpreis = FloatField()

    def get_absolute_url(self):
        return reverse('technology-detail', args=[str(self.technology.id)])

    def __str__(self):
        return f"{self.technology.name.upper()} {self.name.upper()}"


class ToolAttribute(models.Model):
    # Leistungsfähigkeitsprofil
    name = CharField(max_length=255)
    tool = ForeignKey(Tool, on_delete=models.CASCADE)
    a = FloatField()
    b = FloatField()
    c = FloatField()
    d = FloatField()
    einheit = CharField(max_length=255, null=True)

    def clean(self) -> None:
        self.clean_fields(exclude=['tool'])

        # validate if values are ascending or descending
        # Fehler falls Fuzzy springt (bsp. 1, 5, 3, 6)
        if not (self.a <= self.b <= self.c <= self.d or
                self.a >= self.b >= self.c >= self.d):
            raise ValidationError('''A,B,C und D muessen in ab- oder
             aufsteigender Reihenfolge initialisiert werden''')

    def fuzzy_check(self, value: float) -> str:
        # simple fuzzy check

        # range from b to c -> Is possible
        if self.b <= value <= self.c:
            return 'technologisch Machbar'

        # range from a to d -> Is experimental
        elif self.a <= value <= self.d:
            return 'technologische Machbarkeit mit Unsicherheiten'

        # if value out of bounds -> not possible
        else:
            return 'technologisch NICHT umsetzbar'

    def get_absolute_url(self):
        return reverse('technology-detail', args=[str(self.tool.technology.id)])

    def __str__(self):
        return f"{self.name} {self.tool.name}"


'''
Referenzsystem, Bauteil und Volumentabellen
ReferenzSystem, Item, Feature, FeatureAttribute, FeatureAttributeText, Volume,
Halbzeug
'''


class ReferenceSystem(models.Model):
    # Referenzsystem mit Referenzbauteil
    name = CharField(max_length=255)
    technologies = ManyToManyField(
        Tool, through='FctMembership')

    # wirtschaftliche Parameter
    laufzeit_jahr = FloatField()
    betrachtungszeitraum = FloatField()
    produktpreis = FloatField()
    lohnnebenkostenanteil = FloatField()
    dichte = FloatField()
    kilopreis = FloatField()

    def get_absolute_url(self):
        return reverse('referencemodel-detail', args=[str(self.id)])

    def __str__(self):
        return f"{self.name}"


class Item(models.Model):
    # Bauteile
    name = CharField(max_length=255)
    # Bauteil hat Referenz zum Referenzsystem
    # --> Bauteil ist Referenzsystem
    reference = models.OneToOneField(
        ReferenceSystem,
        on_delete=models.CASCADE,
        null=True,
        blank=True)
    # Bauteil hat Abhängigkeit zum Referenzsystem
    # --> Bauteil ist Vergleichssystem
    compare_reference = ForeignKey(
        ReferenceSystem,
        related_name='compare_reference',
        on_delete=models.CASCADE,
        null=True,
        blank=True)

    def get_absolute_url(self):
        return reverse('item-detail', args=[str(self.id)])

    def __str__(self):
        return f"Bauteil: {self.name}"


class Feature(models.Model):
    # Feature Name, Klassifier, Bauteil
    name = models.CharField(max_length=255)
    classifier = models.CharField(max_length=255)
    item = ForeignKey(Item, on_delete=models.CASCADE)
    # is_positive gibt an, ob bei der Volumenberechnung einer
    # Technologiespalte in der das Volumen abgezogen oder addiert wird
    is_positive = BooleanField()
    #
    add_to_fct = BooleanField(null=True, blank=True)

    def __str__(self):
        return f"{self.id} {self.name} {self.classifier} "


class FeatureAttribute(models.Model):
    # Merkmale numerisch
    name = CharField(max_length=255)
    value = FloatField()
    feature = ForeignKey(Feature, on_delete=models.CASCADE)

    def __str__(self):
        return f"{self.id} {self.name} {self.value}"


class FeatureAttributeText(models.Model):
    # Merkmale text
    name = CharField(max_length=255)
    value = CharField(max_length=255, null=True, blank=True)
    feature = ForeignKey(Feature, on_delete=models.CASCADE)

    def __str__(self):
        return f"{self.id} {self.name} {self.value}"


class Volume(models.Model):
    # Volumenabspeicherung der Feature in Abhängigkeit
    # der volumenbeschreibenden Merkmale
    # benötigt für die Berechnung der In- und Outputvolumen
    PRISMATISCH = 'prismatisch'
    ROTATIONSSYMMETRISCH = 'rotationssymmetrisch'
    INITIAL_FEATURE = 'initial_feature'
    ABSATZ = 'absatz'
    T_NUT = 't-nut'
    NUT = 'nut'
    TASCHE = 'tasche'
    PASSFEDER = 'passfeder'
    BOHRUNG = 'bohrung'
    ZYLINDERSENKUNG = 'zylindersenkung'
    KEGELSENKUNG = 'kegelsenkung'
    WELLENABSATZ_ZYLINDRISCH = 'wellenabsatz-zylindrisch'
    WELLENABSATZ_KONISCH = 'wellenabsatz-konisch'
    INNENGEWINDE = 'innengewinde'
    VOLUME_FORM = [
        (PRISMATISCH, 'Prismatisch'),
        (ROTATIONSSYMMETRISCH, 'Rotationssymmetrisch'),
        (INITIAL_FEATURE, 'Initial Feature'),
        (ABSATZ, 'Absatz'),
        (T_NUT, 'T-Nut'),
        (NUT, 'Nut'),
        (TASCHE, 'Tasche'),
        (PASSFEDER, 'Passfeder'),
        (BOHRUNG, 'Bohrung'),
        (ZYLINDERSENKUNG, 'Zylindersenkung'),
        (KEGELSENKUNG, 'Kegelsenkung'),
        (WELLENABSATZ_ZYLINDRISCH, 'Wellenabsatz-Zylindrisch'),
        (WELLENABSATZ_KONISCH, 'Wellenabsatz-Konisch'),
        (INNENGEWINDE, 'Innengewinde')
    ]

    # alle vorkommenden volumenbesschreibenden Merkmale für alle
    # betrachteten Features
    volume_type = CharField(max_length=255, choices=VOLUME_FORM)
    hoehe = FloatField(null=True, blank=True)
    breite = FloatField(null=True, blank=True)
    laenge = FloatField(null=True, blank=True)
    tiefe = FloatField(null=True, blank=True)
    durchmesser = FloatField(null=True, blank=True)
    breite_fuss = FloatField(null=True, blank=True)
    tiefe_fuss = FloatField(null=True, blank=True)
    winkel = FloatField(null=True, blank=True)
    volume = FloatField(null=True, blank=True)
    # one to many nicht erforderlich
    feature = ForeignKey(Feature, on_delete=models.CASCADE, null=True)

    def validating_attributes(self, attributes: List[decimal.Decimal]) -> None:
        # generic validation
        if None in attributes:
            raise ValidationError(
                f''' Typ "{self.volume_type}" hat folgende Werte erhalten:
                {", ".join(map(str,attributes))}''')

    # Zuordnung in Abhängigkeit der Classifier welche Merkmale benötigt werden
    # Abhängig vom Feature
    def clean(self) -> None:
        self.clean_fields()
        # bei Absatz und Prismatisch (Initialfeature/Kontur)
        if self.volume_type in [self.PRISMATISCH, self.ABSATZ]:
            self.validating_attributes([self.hoehe, self.breite, self.laenge])

        # bei Wellenabsatz, Bohrung und Rotationssymme (Initialfeature/Kontur)
        elif self.volume_type in [self.ROTATIONSSYMMETRISCH,
                                  self.WELLENABSATZ_ZYLINDRISCH, self.BOHRUNG]:
            self.validating_attributes([self.durchmesser, self.laenge])

        # T-Nut
        elif self.volume_type == self.T_NUT:
            self.validating_attributes([self.breite, self.laenge, self.tiefe,
                                        self.breite_fuss, self.tiefe_fuss])

        # Nut, Tasche, Passfeder
        elif self.volume_type in [self.NUT, self.TASCHE, self.PASSFEDER]:
            self.validating_attributes([self.breite, self.laenge, self.tiefe])

        # Zylindersenkung Kegelsenkung
        elif self.volume_type in [self.ZYLINDERSENKUNG, self.KEGELSENKUNG]:
            self.validating_attributes([self.durchmesser, self.tiefe])

        # konischer Wellenabsatz
        elif self.volume_type == self.WELLENABSATZ_KONISCH:
            self.validating_attributes(
                [self.durchmesser, self.laenge, self.winkel])
        # Innengewinde (in diesem Fall nicht berechnet)
        elif self.volume_type == self.INNENGEWINDE:
            pass

        # Falls Feature keins dieser ausgewählten ist
        # --> Feature hat unbekanntes Volumen, keine Berücksichtigung in Berechnung
        else:
            assert False, f'In "clean()": Unbekannts Volumen "{self.volume_type}"'

    # Berechnungsformeln in Abhängigkeit der Zuordnung
    def calculate_volume(self) -> float:
        # Initialfeature prismatisch und Absatz

MyProjekt/main/forms.py
import logging
from typing import Any, Dict
from django import forms
from django.core.exceptions import ValidationError
from django.forms.fields import FloatField
from django.forms.formsets import formset_factory
from django.forms.models import ModelChoiceField


from .utils import processing_excel_file_buffer
from .models import FctMembership, ReferenceSystem, Tool

log = logging.getLogger(__name__)


class ReferenceItemUploadForm(forms.Form):
    '''
    Eingabefelder und Logik nach dem hochladen des Referenzbauteils
    '''
    name = forms.CharField(max_length=255)
    file = forms.FileField()
    prismatic = forms.BooleanField(initial=True, required=False)
    laenge = forms.FloatField(required=False)
    breite = forms.FloatField(required=False)
    hoehe = forms.FloatField(required=False)
    durchmesser = forms.FloatField(required=False)

    def clean(self) -> Dict[str, Any]:
        # beim hochladen cleanen und säubern
        # get buffer from cleaned_data form
        super().clean()
        file_buffer = self.cleaned_data.get('file')
        try:
            # process buffer and create datafame
            df = processing_excel_file_buffer(self, file_buffer)
            self.process_dataframe = df

            # simple verification
            verification_names = [
                'name', 'classifier', 'prismatic', 'positive']
            if not all(item in df.columns.tolist()
                       for item in verification_names):
                raise ValidationError('Excel-Format stimmt nicht.')

        # consume error generate by processing buffer or validation
        except Exception as err:
            log.exception(err)
            raise ValidationError('Fehler beim lesen der Excel')


class ItemUploadForm(forms.Form):
    '''
    Eingabefelder und Logik nach dem hochladen des Vergleichsbauteil
    ähnliches Vorgehen wie bei Referenzupload mit zusätlicher 
    compare_referenz Instanz
    '''
    name = forms.CharField(max_length=255)
    compare_reference = forms.ModelChoiceField(
        queryset=ReferenceSystem.objects.all())
    file = forms.FileField()
    prismatic = forms.BooleanField(initial=True, required=False)
    laenge = forms.FloatField(required=False)
    breite = forms.FloatField(required=False)
    hoehe = forms.FloatField(required=False)
    durchmesser = forms.FloatField(required=False)

    def clean(self) -> Dict[str, Any]:
        # get buffer from cleaned_data form
        super().clean()
        file_buffer = self.cleaned_data.get('file')
        try:
            # process buffer and create datafame
            df = processing_excel_file_buffer(self, file_buffer)
            self.process_dataframe = df

            # simple verification
            verification_names = [
                'name', 'classifier', 'prismatic', 'positive']
            if not all(item in df.columns.tolist()
                       for item in verification_names):
                raise ValidationError('Excel-Format stimmt nicht.')

        # consume error generate by processing buffer or validation
        except Exception as err:
            log.exception(err)
            raise ValidationError('Fehler beim lesen der Excel')


class AddTechnologyToReferenceSystemForm(forms.Form):
    '''
    Eingabefelder für das Hinzufügen von Technologien in die 
    Fertigungsprozessfolge
    '''
    technology = forms.ModelChoiceField(queryset=Tool.objects.all())
    hauptzeit = FloatField()
    standmenge = FloatField()
    losgroesse = FloatField()


class FctTableRowForm(forms.Form):
    '''
    Eingabefelder für das Füllen der FCT-Tabelle
    '''
    tool_attribute = ModelChoiceField(queryset=Tool.objects.all())
    input = FloatField()
    output = FloatField()

MyProjekt/main/templates/main/technology/attribute_delete.html
{% extends "base.html" %}{% load static %}
{% block content %}
<div class="container mt-3">
  <div class="row">
    <div class="header mb-2">
      <h2 class='display-4 text-center pb-5' style='font-size:70px;'>
        Leistungsfähigkeitsprofil löschen
      </h2>
      <ul>
        <a class="w-20 btn btn-light m-3" href="{% url 'technology-detail' technology.id %}"><i
            class="fas fa-arrow-left"></i>
          Zurück</a>
        <p style="color:crimson">Bist du dir sicher, dass du das Leistungsfähigkeitsprofil löschen möchtest?</p>
        <form method="POST">
          {% csrf_token %}
          <input class="w-20 btn btn-danger" type="submit" value="Ja, bin ich.">
        </form>
      </ul>
    </div>
  </div>
</div>
{% endblock %}

MyProjekt/main/templates/main/technology/attribute_form.html
{% extends "base.html" %}{% load static %}
{% block content %}
<div class="container mt-3">
  <div class="row">
    <div class="header mb-2">
      <h2 class='display-4 text-center pb-5' style='font-size:70px;'>
        Leistungsfähigkeitsprofil
      </h2>
      <ul>
        <a class="w-20 btn btn-secondary m-3" href="{% url 'technology-detail' tool.technology.id %}"><i
            class="fas fa-arrow-left"></i>
          Zurück</a>
        <form method="post">
          {% csrf_token %}
          <table>
            {{ form.as_table }}
          </table>
          <input class="w-20 btn btn-success mt-1" type="submit" value="Technologie hinzufügen">
        </form>
      </ul>
    </div>
  </div>
  {% endblock %}

MyProjekt/main/templates/main/technology/attribute_update.html
{% extends "base.html" %}{% load static %}
{% block content %}
<div class="container mt-3">
  <div class="row">
    <div class="header mb-2">
      <h2 class='display-4 text-center pb-5' style='font-size:70px;'>
        Leistungsfähigkeitsprofil:
      </h2>
      <ul>
        <a class="w-20 btn btn-secondary m-3" href="{% url 'technology-detail' attr.tool.technology.id %}"><i
            class="fas fa-arrow-left"></i>
          Zurück</a>
        <form method="post">
          {% csrf_token %}
          <table>
            {{ form.as_table }}
          </table>
          <input class="w-20 btn btn-success mt-1" type="submit" value="Technologie hinzufügen">
        </form>
      </ul>
    </div>
  </div>
</div>
{% endblock %}

MyProjekt/main/templates/main/technology/detail.html
{% extends "base.html" %}
{% block content %}
<div class="container mt-3">
  <div class="row">
    <div class="header mb-2">
      <p class="display-5 text-center">Technologie</p>
      <p class='display-1 text-center'>
        {{object.name}}
      </p>
      <ul>
        <a class="w-20 btn btn-secondary mt-1" href="{% url 'technology-list' %}"><i class="fas fa-arrow-left"></i>
          Zurück</a>
        <a class="w-20 btn btn-light mt-1" style="color: orange;" href="{% url 'technology-update' object.id %}"><i
            class="fas fa-pencil-alt"></i>
          Update</a>
        <a class="w-20 btn btn-light mt-1" style="color: red;" href="{% url 'technology-delete' object.id %}"><i
            class="far fa-trash-alt"></i>
          Technologie löschen</a>
        <a class="w-20 btn btn-primary mt-1" href="{% url 'tool-create' object.id %}"><i class="fas fa-hammer"></i>
          Werkzeug anglegen</a>
      </ul>
      <div class="container mb-2" style="background-color:rgb(255, 245, 238, 0.8) ;border-radius: 4px;
          color: rgba(21, 52, 78, 0.8);">
        <h5 class="pt-1">
          Maschinenparameter
        </h5>
        <div class="table-responsive">
          <table class="table table-striped table-hover table-sm">

            <thead>
              <tr>
                <td scope="col">Anschaffungswert</td>
                <td scope="col">Verkaufserlös</td>
                <td scope="col">Abschreibungsdauer</td>
                <td scope="col">Platzbedarf</td>
                <td scope="col">mittlere Leistung</td>
                <td scope="col">Restfertigungsgemeinkosten</td>
                <td scope="col">Instandhaltungsfaktor</td>
                <td scope="col">Quadratmeterpreis</td>
                <td scope="col">Strompreis</td>
                <td scope="col">Stundenlohn</td>
                <td scope="col">Zinssatz</td>
                <td scope="col">Anzahl Fertigungsmittel</td>
                <td scope="col">Bediehnverhältnis</td>
              </tr>
            </thead>
            <tbody>
              <td>{{object.anschaffungswert}} €</td>
              <td>{{object.verkaufserlös}} €</td>
              <td>{{object.abschreibungsdauer}} a</td>
              <td>{{object.platzbedarf}} qm</td>
              <td>{{object.mittlere_leistung}} kW</td>
              <td>{{object.restfertigungsgemeinkosten}} €</td>
              <td>{{object.instandhaltungsfaktor}}</td>
              <td>{{object.quadratmeterpreis}} €/qm</td>
              <td>{{object.strompreis}} €/kWh</td>
              <td>{{object.stundenlohn}} €/h</td>
              <td>{{object.zinsatz}}</td>
              <td>{{object.fertigungsmittelanzahl}}</td>
              <td>{{object.bediehnverhaeltnis}}</td>
            </tbody>
          </table>
        </div>
      </div>
    </div>
  </div>
  <div class="container" style="background-color:rgb(255, 245, 238, 0.8) ;border-radius: 4px;
  color: rgba(21, 52, 78, 0.8);">
    <div class="row">
      <div class="col">
        <p class="display-5 text-center">
          Liste der Werkzeuge
        </p>
      </div>
    </div>
    {% for tool in tools %}
    <div class="row p-1">
      <div class="col d-flex flex-column " style="background-color: rgba(21, 52, 78, 0.8);border-radius: 4px;">
        <div class="row">
          <div class="col-sm">
            <div class="row-sm">
              <h3 style="color: seashell;">
                {{tool.name}}
              </h3>
            </div>
            <div class="row-sm">
              <a class="w-20 btn btn-light mt-1" style="color: orange;" href="{% url 'tool-update' tool.id %}"><i
                  class="fas fa-pencil-alt"></i>
              </a>
              <a class="w-20 btn btn-light mt-1" style="color: red;"
                href="{% url 'tool-delete' pk=tool.id technology_id=object.id %}"><i class="far fa-trash-alt"></i>
              </a>
            </div>
          </div>
          <div class="col-sm-8">
            <h5 class="pt-1" style="color: seashell;">
              technologische Parameter
            </h5>
            <div class="table-responsive">
              <table class="table table-striped table-hover table-sm" style="color: seashell;">
                <thead>
                  <tr>
                    <td scope="col">Verteilzeit</td>
                    <td scope="col">Rüstzeit</td>
                    <td scope="col">Erholungszeit</td>
                    <td scope="col">Werkzeugwechselzeit</td>
                    <td scope="col">Werkstückwechselzeit</td>
                    <td scope="col">Betriebsstoffkosten</td>
                    <td scope="col">Werkzeugpreis</td>
                  </tr>
                </thead>
                <tbody>
                  <td style="color: seashell;">{{tool.verteilzeit}} s</td>
                  <td style="color: seashell;">{{tool.ruestzeit}} s</td>
                  <td style="color: seashell;">{{tool.erholungszeit}} s</td>
                  <td style="color: seashell;">{{tool.werkzeugwechselzeit}} s</td>
                  <td style="color: seashell;">{{tool.werkstueckwechselzeit}} s</td>
                  <td style="color: seashell;">{{tool.betriebsstoffkosten}} €</td>
                  <td style="color: seashell;">{{tool.werkzeugpreis}} €</td>
                </tbody>
              </table>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="row p-4">
      <div class="col-sm">
        <div class="row">
          <h4>
            Leistungsfähigkeitsprofile
          </h4>
        </div>
        <div class="row-sm">
          <a class="w-20 btn btn-primary mt-1" href="{% url 'attr-create' tool.id %}"><i class="fas fa-plus">
            </i> Leistungsfähigkeitsprofil</a>
        </div>
      </div>
      <div class="col-sm">
        {% for attr in tool.toolattribute_set.all %}
        <div class="row m-2" style="background-color: rgba(21, 52, 78, 0.8);border-radius: 4px;">
          <div class="col-sm" style="color: seashell;">
            <h5>
              {{attr.name}}
            </h5>
            <a class="btn btn-light rounded-circle change" style="color: orange;"
              href="{% url 'attr-update' pk=attr.id %}"><i class="fas fa-pencil-alt"></i></a>
            <a class="btn btn-light rounded-circle delete" style="color: red;"
              href="{% url 'attr-delete' pk=attr.id technology_id=object.id %}"><i class="far fa-trash-alt"></i>
            </a>
          </div>
          <div class="col-sm">
            <div class="table-responsive">
              <table class="table table-striped table-hover table-sm" style="color: seashell;">
                <thead>
                  <p class="pt-1" style="color: seashell;">
                    Fuzzyparameter in {{attr.einheit}}
                  </p>
                  <tr>
                    <td scope="col">a</td>
                    <td scope="col">b</td>
                    <td scope="col">c</td>
                    <td scope="col">d</td>
                  </tr>
                </thead>
                <tbody>
                  <td style="color: seashell;">{{attr.a}}</td>
                  <td style="color: seashell;">{{attr.b}}</td>
                  <td style="color: seashell;">{{attr.c}}</td>
                  <td style="color: seashell;">{{attr.d}}</td>
                </tbody>
              </table>
            </div>
          </div>
        </div>
        {% endfor %}
      </div>
    </div>
    {% endfor %}
  </div>
</div>
<style>
  .delete:hover {
    font-size: 15px;
    border-color: red;
  }

  .change:hover {
    font-size: 15px;
    border-color: orange;
  }
</style>
{% endblock %}